
# Don't modify comment
module MainFrameMod
 require 'wx'
 include Wx
 ID_CMP_43 = 10043
 ID_CMP_67 = 10067
 ID_MENU_OPTION,ID_MENU_REPORT,ID_MENU_HIDE,ID_MENU_EXIT,ID_MENU_ABOUT = 57,58,62,59,61
 #[inc]add your include files here
 require 'kconv'
 require 'MyTaskBarIcon.rb'
 require 'OptionDialog.rb'
 require 'hks_report.rb'
 DEFAULT_AUTO_REPORT_FLAG = true
 DEFAULT_AUTO_REPORT_INTERVAL = 60
 AUTO_REPORT_CHECK_INTERVAL = (60 * 1000)   #60sec #[inc]end your include

 class MainFrame < Frame 
    def initialize(parent,id=-1,title='',pos = Point.new(1,1),size = Size.new(525,490),style = DEFAULT_FRAME_STYLE,name = 'frame')
        super(parent,id,title,pos,size,style,name)
        initBefore()
        VwXinit()
        initAfter()

    end #end function

    def VwXinit()
        show(false)
        evt_iconize(){|event|VwXEvOnIconize(event)}
        @menubar= MenuBar.new
        @menu_file = Menu.new
        @menubar.append(@menu_file,"ファイル")
        @menu_tool = Menu.new
        @menubar.append(@menu_tool,"ツール")
        itemmenu = MenuItem.new(@menu_tool,ID_MENU_OPTION,"オプション","",ITEM_NORMAL)
        @menu_tool.append_item(itemmenu)
        itemmenu = MenuItem.new(@menu_file,ID_MENU_REPORT,"手動で報告","",ITEM_NORMAL)
        @menu_file.append_item(itemmenu)
        itemmenu = MenuItem.new(@menu_file,ID_MENU_HIDE,"ウィンドウを隠す","",ITEM_NORMAL)
        @menu_file.append_item(itemmenu)
        @menu_file.append_separator()
        itemmenu = MenuItem.new(@menu_file,ID_MENU_EXIT,"終了","",ITEM_NORMAL)
        @menu_file.append_item(itemmenu)
        @menu_help = Menu.new
        @menubar.append(@menu_help,"ヘルプ")
        itemmenu = MenuItem.new(@menu_help,ID_MENU_ABOUT,"このソフトについて","",ITEM_NORMAL)
        @menu_help.append_item(itemmenu)
        set_menu_bar(@menubar)
        evt_menu(ID_MENU_REPORT){|event|on_report(event)}
        evt_menu(ID_MENU_OPTION){|event|on_option(event)}
        evt_menu(ID_MENU_HIDE){|event|on_hide(event)}
        evt_menu(ID_MENU_EXIT){|event|on_exit(event)}
        evt_menu(ID_MENU_ABOUT){|event|on_about(event)}
        @w_main = Window.new(self,-1,Point.new(0,0),Size.new(519,438))
        @bt_hide = Button.new(@w_main,-1,"",Point.new(286,390),Size.new(100,25))
        @bt_hide.set_label('ウィンドウを隠す')
        @bt_hide.evt_button(@bt_hide.get_id()){|event|on_hide(event)}
        @txm_report_result = TextCtrl.new(@w_main,-1,"",Point.new(26,66),Size.new(460,304),TE_READONLY|TE_MULTILINE)
        @bt_report = Button.new(@w_main,-1,"",Point.new(135,390),Size.new(100,25))
        @bt_report.set_label('手動で報告')
        @bt_report.evt_button(@bt_report.get_id()){|event|on_report(event)}
        @tx_latest_report = TextCtrl.new(@w_main,-1,"",Point.new(340,30),Size.new(145,22),TE_READONLY)
        @st_latest_report = StaticText.new(@w_main,-1,"",Point.new(256,31),Size.new(86,19),ST_NO_AUTORESIZE)
        @st_latest_report.set_label('最終報告時刻 :')
        @nam_thread_schedule = Timer.new(self,ID_CMP_43)
        evt_timer(ID_CMP_43){|event|nam_thread_schedule_VwXEvOnTimer(event)}
        @nam_auto_report = Timer.new(self,ID_CMP_67)
        evt_timer(ID_CMP_67){|event|nam_auto_report_VwXEvOnTimer(event)}
        refresh()
    end
    def VwXDelComp()
        if(@nam_auto_report != nil): @nam_auto_report = nil end
        if(@nam_thread_schedule != nil): @nam_thread_schedule = nil end
    end

#[win]add your code here

    def initBefore()
        #add your code here
        load_option
        @taskbar = MyTaskBarIcon.new(self)
        @elapsed_time = 0
        @report_thread = nil
        evt_close { |event|
            @taskbar.destroy
            @nam_thread_schedule.stop
            Thread.kill(@report_thread) if @report_thread
            VwXDelComp()
            event.skip
        }
    end

    def initAfter()
        #add your code here
        @nam_thread_schedule.start(10)
        @nam_auto_report.start(AUTO_REPORT_CHECK_INTERVAL) if $option['auto_report_flag']
        @txm_report_result.set_value("報告結果が表示されます")
        @tx_latest_report.set_value("なし")
        centre()
    end
    
    def nam_thread_schedule_VwXEvOnTimer(event) #init function
        #[413]Code event VwX...Don't modify[413]#
        #add your code here
        Thread.pass
    end #end function

    
    def load_option()
        $option_file = 'Tenmite.yaml'
        unless File.exist?($option_file) then
            $option = {}
            $option['auto_report_flag'] = DEFAULT_AUTO_REPORT_FLAG
            $option['auto_report_interval'] = DEFAULT_AUTO_REPORT_INTERVAL
            File.open($option_file, 'w') { |f|
                f.puts $option.to_yaml
            }
        end
        $option = YAML.load_file($option_file)
        if !$option then
            $option = {}
        end
        if $option['auto_report_flag']==nil then
            $option['auto_report_flag'] = DEFAULT_AUTO_REPORT_FLAG
        end
        if $option['auto_report_interval']==nil || $option['auto_report_interval'] < 15 then
            $option['auto_report_interval'] = DEFAULT_AUTO_REPORT_INTERVAL
        end
#        pp $option
    end

    def save_option(option)
        $option['auto_report_flag'] = option['auto_report_flag']
        $option['auto_report_interval'] = option['auto_report_interval']
        File.open($option_file, 'w') { |f|
            f.puts $option.to_yaml
        }
#        pp $option
        if $option['auto_report_flag'] then
            @elapsed_time = 0
            @nam_auto_report.start(AUTO_REPORT_CHECK_INTERVAL) 
        else
            @nam_auto_report.stop
            @elapsed_time = 0
        end
    end
    
    def on_option(event) #init function
        #[1ab]Code menu VwX...Don't modify[1ab]#
        #add your code here
        dlg = OptionDialogMod::OptionDialog.new(self)
        dlg.set_parent(self)
        dlg.show_modal
    end #end function


    def on_exit(event) #init function
        #[23f]Code menu VwX...Don't modify[23f]#
        #add your code here
        close
    end #end function

    def on_hide(event) #init function
        #[4e3]Code menu VwX...Don't modify[4e3]#
        #add your code here
        self.show(false)
    end #end function

    def VwXEvOnIconize(event) #init function
        #[4ae]Code event VwX...Don't modify[4ae]#
        #add your code here
        on_hide(event)
        event.skip()
    end #end function


    def report()
        if !@report_thread then
            @report_thread = Thread.start {
                @txm_report_result.set_value("報告中...")
                result = TencoClient.new.run
                case result
                when -1
                    @txm_report_result.set_value("報告は中断を中止しました。\nログファイル'Tenmite.log'を開くことが出来ませんでした。\n")
                else
                    begin
                        File.open('Tenmite.log') { |f|
                            @txm_report_result.set_value(f.read.kconv(Kconv::UTF8, Kconv::SJIS))
                        }
                    rescue
                        @txm_report_result.set_value("報告結果を表示することが出来ません。\nログファイル'Tenmite.log'を開くことが出来ませんでした。\n")
                    end
                end
                now = Time.now.strftime("%Y/%m/%d %H:%M:%S")
                @tx_latest_report.set_value(now)
                @report_thread = nil
            }
        end
        @elapsed_time = 0
    end

    def on_report(event) #init function
        #[1d6]Code menu VwX...Don't modify[1d6]#
        #add your code here
        if @report_thread then
            message_box('既に報告処理を実施しています！','警告',Wx::ICON_WARNING)
            return
        end
        report
    end #end function

    def nam_auto_report_VwXEvOnTimer(event) #init function
        #[7b3]Code event VwX...Don't modify[7b3]#
        #add your code here
        @elapsed_time += 1
        p @elapsed_time
        if @elapsed_time >= $option['auto_report_interval'] then
            report
            @elapsed_time = 0
        end
    end #end function


    def on_about(event) #init function
        #[5e8]Code menu VwX...Don't modify[5e8]#
        #add your code here
        msg = <<-EOS
テンコ様がみてる ver0.01
（Tenco! ver0.07cをベースに作成しています。）
        EOS
        message_box(msg,'このソフトについて')
    end #end function

#[win]end your code
 end
end

