
class MyTaskBarIcon < Wx::TaskBarIcon
    
    ID_OPEN,ID_OPTION,ID_ABOUT = 20,21,22
    ICON_ICO = 'Tenmite.ico'
    ICON_GIF = 'Tenmite.gif'
    ICON_XBM = 'Tenmite.xbm'
    ICON_XPM = 'Tenmite.xpm'
    DEFAULT_ICON_XPM = <<-EOS
/* XPM */
static char *help_xpm[] = {
/* columns rows colors chars-per-pixel */
"16 15 4 1",
"  c None",
". c Black",
"X c Blue",
"o c #000080",
/* pixels */
"                ",
"  ............  ",
"  .XXXXXXXXXX.  ",
"  .XXXXXXXXXX.  ",
"  .....XX.....  ",
"      .XX.      ",
"      .XX.      ",
"      .XX.      ",
"      .XX.      ",
"      .XX.      ",
"      .XX.      ",
"      .XX.      ",
"      .XX.      ",
"      ....      ",
"                "
};
    EOS
    
    def initialize(parent)
        super()
        @parent = parent
        if File.exist?(ICON_ICO) then
            icon = Wx::Icon.new(ICON_ICO, Wx::BITMAP_TYPE_ICO)
        elsif File.exist?(ICON_GIF) then
            icon = Wx::Icon.new(ICON_GIF, Wx::BITMAP_TYPE_GIF)
        elsif File.exist?(ICON_XBM) then
            icon = Wx::Icon.new(ICON_XBM, Wx::BITMAP_TYPE_XBM)
        elsif File.exist?(ICON_XPM) then
            icon = Wx::Icon.new(ICON_XPM, Wx::BITMAP_TYPE_XPM)
        else
            File.open(ICON_XPM,'w') { |f|
                f.print(DEFAULT_ICON_XPM)
            }
            icon = Wx::Icon.new(ICON_XPM, Wx::BITMAP_TYPE_XPM)
        end
        set_icon(icon, 'テンコ様がみてる')
        evt_taskbar_left_dclick  {|evt| on_taskbar_activate(evt) }
    end


    def create_popup_menu()
        menu = Wx::Menu.new
        menu.append(ID_OPEN, 'ウィンドウを開く')
        menu.append(ID_OPTION, '設定')
        menu.append_separator()
        menu.append(ID_ABOUT, 'このソフトについて')
        menu.append_separator()
        menu.append(ID_EXIT, '終了')
        evt_menu(ID_OPEN) { |event| on_taskbar_activate(event) }
        evt_menu(ID_OPTION) { |event| @parent.on_option(event) }
        evt_menu(ID_ABOUT) { |event| @parent.on_about(event) }
        evt_menu(ID_EXIT) { |event| @parent.on_exit(event) }
        return menu
    end
    
    def on_taskbar_activate(event)
        @parent.show(true)
        event.skip
    end
end
